C
C      **********************************************************************
C      *********************** FUNCTION FACTOR  *****************************
C      **********************************************************************
C
       FUNCTION FACTOR(N)
C
C      *     COMPUTES THE FACTORIAL FUNCTION FOR INTEGERS.                  *
C      *     THIS FUNCTION IS BASED ON PROG. 3-2 ON P. 32 OF "DATA REDUCTION*
C      *     AND ERROR ANALYSIS FOR THE PHYSICAL SCIENCES", PHILIP R.       *
C      *     BEVINGTON, 1969, McGRAW HILL (NY:NY)                           *
C
       IMPLICIT REAL*8 (A-H,O-Z), INTEGER (I-N)
C
       FACTOR=1.0
       IF(N-1 .GT. 0) THEN
   13     IF(N-10 .LE. 0) THEN
C
C      *                N LESS THAN 11                                      *
C
   21        DO 23 I=2,N
                FI=I
                FACTOR=FACTOR*FI
   23        CONTINUE
C
C      *               N GREATER THAN 10                                    *
C
          ELSE
   31        SUM=0.0
             DO 34 I=11,N
                FI=I
                SUM=SUM+DLOG(FI)
   34        CONTINUE
             FACTOR=3628800.0D00*DEXP(SUM)
          ENDIF
       ENDIF
   40  RETURN
       END
