        SUBROUTINE CDSORT (
*
*  inputs
*
     :                  N,
*
*  input/output
*
     :                  ARR)
*
*  Module number:
*
*  Module name:
*
*  Keyphrase:
*  ----------
*  sort by straight insertion
*
*  Description:
*  ------------
*  Sort an array ARR of length N into ascending numerical order, by straight
*  insertion.  ARR is replaced on output by its sorted rearrangement
*  Adapted from the routine PIKSRT on page 227 of Numerical Recipes by
*  Press et. al., 1986.
*
*  FORTRAN name: CDSORT.FOR
*
*  Keywords of accessed files and tables:
*  --------------------------------------
*  Name                         I/O     Description / Comments
*
*  Subroutines Called:
*  -------------------
*  CDBS:
*       None
*  SDAS:
*       UMSPUT
*  Others:
*       None
*
*  History:
*  --------
*  Version      Date        Author          Description
*     1       06-13-89     J.-C. HSU        coding
*
*-------------------------------------------------------------------------------
*
*== input:
*                                       --array size
        INTEGER                 N
*
*== input/output:
*                                       --input/output array
        REAL                    ARR(N)
*
*== local:
*
        REAL                    A
        INTEGER                 I, J
*
*------------------------------------------------------------------------------
*
*  pick each element in turn
*
        DO 12 J = 2, N
            A = ARR(J)
*
*  look for the place to insert it
*
            DO 11 I = J-1, 1, -1
                IF (ARR(I) .LE. A) GO TO 10
                ARR(I+1) = ARR(I)
   11       CONTINUE
            I = 0
*
*  insert it
*
   10       ARR(I+1) = A
   12   CONTINUE
*
        RETURN
        END
