# Iraf script to run wf32d
# Created by W.J. Hack 4Jan99 for ACS
# Modified by  H.A. Bushouse 22Aug00 for WFC3
# Updated by H.A. Bushouse 8Jun2010 to remove atodcorr param

procedure wf32d (input, output)

string input      {"", prompt="input FITS files"}
string output     {"", prompt="output FITS files"}
string dqicorr    {"perform", prompt="Update dq array from bad pixel table",
			min="perform|omit"}
string darkcorr   {"perform", prompt="Subtract dark image",
			min="perform|omit"}
string flatcorr   {"perform", prompt="Multiply by flat field image",
			min="perform|omit"}
string shadcorr   {"omit", prompt="Correct for shutter shading (CCD)",
			min="perform|omit"}
string photcorr   {"perform", prompt="Update photometry keywords",
			min="perform|omit"}
bool   verbose    {no, prompt="Print verbose time stamps?"}
bool   quiet      {no, prompt = "Print messages only to trailer files?"}
string Version    {"08May2012", prompt="Date of Installation"}

begin
        string 	inp, out
	string  exec
	string	wf32dstr, dqi, blev, glin, lflg,
		dark, flat, shad, phot

	# Get input parameters from par file.
	inp = input  ;  out =output
	dqi  = dqicorr   ; dark = darkcorr
        flat = flatcorr  ; shad = shadcorr  ;  phot = photcorr

        # define directory to executable
        exec = osfn ("stsdasbin$")

        # build command string
	wf32dstr = "!" // exec //  "wf32d.e"

        wf32dstr = wf32dstr // " '" // inp // "' '" // out // "'"

        if (verbose)
            wf32dstr = wf32dstr // " -t -v"

        if (dqi == "perform")
            wf32dstr = wf32dstr // " -dqi"

        if (dark == "perform")
            wf32dstr = wf32dstr // " -dark"

        if (flat == "perform")
            wf32dstr = wf32dstr // " -flat"

        if (shad == "perform")
            wf32dstr = wf32dstr // " -shad"

        if (phot == "perform")
            wf32dstr = wf32dstr // " -phot"

        # printf  ("%s\n",wf32dstr)     # to display the string, not run it
	
	# execute
        print (wf32dstr) | cl

        # exit
        print ("")

end
