# Iraf script to run wf3ccd
# Created by W.J. Hack 4Jan99 for ACS
# Modified by H.A. Bushouse 22Aug2000 for WFC3
# Updated by H.A. Bushouse 8Jun2010 to add flshcorr param

procedure wf3ccd (input, output)

string input      {"", prompt="input FITS files"}
string output     {"", prompt="output FITS files"}
string dqicorr    {"perform", prompt="Update dq array from bad pixel table",
			min="perform|omit"}
string atodcorr   {"omit", prompt="Analog-to-digital correction",
			min="perform|omit"}
string blevcorr   {"perform", prompt="Subtract bias from overscan regions",
			min="perform|omit"}
string biascorr   {"perform", prompt="Subtract bias image",
			min="perform|omit"}
string flshcorr   {"omit", prompt="Subtract post-flash image",
			min="perform|omit"}
bool    verbose   {no, prompt="Print verbose time stamps?"}
bool    quiet     {no, prompt = "Print messages only to trailer files?"}
string  Version   {"01Dec2010", prompt="Date of Installation"}

begin
        string 	inp, out, outb
	string  exec
	string	ccdstr, dqi, atod, blev, bias, flsh

	# Get input parameters from par file.
	inp = input  ;  out =output  
	dqi = dqicorr   ; atod = atodcorr  ;  blev = blevcorr
	bias = biascorr 
	flsh = flshcorr

        # define directory to executable
        exec = osfn ("stsdasbin$")

        # build command string
	ccdstr = "!" // exec //  "wf3ccd.e"

        ccdstr = ccdstr // " '" // inp // "' '" // out // "'"

        if (verbose)
            ccdstr = ccdstr // " -t -v"

        if (dqi == "perform")
            ccdstr = ccdstr // " -dqi"

        if (atod == "perform")
            ccdstr = ccdstr // " -atod"

        if (blev == "perform")
            ccdstr = ccdstr // " -blev"

        if (bias == "perform")
            ccdstr = ccdstr // " -bias"

        if (flsh == "perform")
            ccdstr = ccdstr // " -flash"

        # printf  ("%s\n",ccdstr)     # to display the string, not run it

	# execute
        print (ccdstr) | cl

        # exit
        print ("")

end
