# cl wrapper for wf3rej
# Created by W.J. Hack 4Jan99 for ACS
# Modified by H.A. Bushouse 22Aug2000 for WFC3
#
procedure wf3rej (input,output)

file    input    	{"",prompt="Input WFC3 file name(s)"}
file	output	 	{"",prompt="Name of output file"}
file    crrejtab 	{"",prompt="Reference file name"}
file	scalense	{"",prompt="Scale factor applied to noise"}
file    initgues	{"",prompt="Initial value estimate scheme (min|med)"}
file	skysub		{"",prompt="How to compute the sky (none|mode|mean)"}
file	crsigmas	{"",prompt="Rejections levels in each iteration"}
real    crradius	{-1.,prompt="CR expansion radius in pixels"}
real    crthresh        {-1.,prompt="Rejection propagation threshold"}
int	badinpdq        {-1,prompt="Data quality flag bits to reject"}
bool    crmask          {no,prompt="Flag CR in input DQ images? "} 
bool    shadcorr 	{no,prompt="Perform shading shutter correction?"}
bool    verbose  	{no,prompt="Print verbose messages?"}
string  Version  	{"08May2012",prompt="Date of Installation"}

begin

	# local variables
        file    inp, out, crfile, init, skymode, sigma, noise
	real    radius, thresh
	int     dq
	string  crrejstr, exec
	bool	mask, shad

	# get input parameters from par files
	inp = input     ;      out = output    ;   crfile = crrejtab
	init = initgues ;  skymode = skysub    ;    sigma = crsigmas
	noise = scalense;   radius = crradius  ;   thresh = crthresh 
	dq = badinpdq   ;     mask = crmask    ;     shad = shadcorr


	# Check values of some input parameters.
	if ( init != "min" && init != "med" && init != "" )
	     error (1, "Input parameter 'initgues' out of range")
	if ( skymode != "none" && skymode != "mode" && skymode != "mean" && skymode != "" )
	     error (1, "Input parameter 'skysub' out of range")

        # define bin directory to unix executables
	exec = osfn ("stsdasbin$")

	# Build command string
	crrejstr = "!" // exec //  "wf3rej.e"

	crrejstr = crrejstr // " '" // inp // "' '" // out // "'"

	if (verbose)
	    crrejstr = crrejstr // " -t -v "

	if (shad)
	    crrejstr = crrejstr // " -shadcorr "

	if (mask )
	     crrejstr = crrejstr // " -crmask "

	if (crfile != "" ) 
	    crrejstr = crrejstr // " -table '" // crfile // "'"

	if (noise != "")
	    crrejstr = crrejstr // " -scale " // noise 
	
	if (init != "")
	    crrejstr = crrejstr // " -init " // init

	if (skymode != "")
	    crrejstr = crrejstr // " -sky " // skymode

	if (sigma != "")
	    crrejstr = crrejstr // " -sigmas '" // sigma // "'"

	if (radius >= 0.)
	    crrejstr = crrejstr // " -radius " // radius

	if (thresh >= 0.)
	    crrejstr = crrejstr // " -thresh " // thresh

	if (dq >= 0)
	    crrejstr = crrejstr // " -pdq " // dq

	# printf  ("%s\n",crrejstr)      # to display the string, not run it

	# execute
	print (crrejstr) | cl

	# exit
	print ("")

end
