# F_NPTS    size of X & Y arrays
# F_NPAR    total number of parameters (size of VAR & PAR arrays)
# F_XMIN    minimum X value
# F_XMAX    maximum X value
# F_YMIN    minimum Y value
# F_YMAX    maximum Y value
# F_OPTION  least squares or least absolute value
# F_LOGFILE fd for log file or NULL if no log file
# F_X       independent variable values
# F_Y       dependent variable values
# F_VAR     true if parameter is to be varied
# F_PAR     values of parameters (both variable and fixed parameters)
#		The values of the variable parameters will not be updated with
#		the values obtained by fitting until the fitting is complete.

define	LEN_FFIT	12
define	MPAR		20		# max number of parameters
define	F_LEAST_SQUARES	1
define	F_MINSUM	2

define	F_NPTS		Memi[$1]
define	F_NPAR		Memi[$1+1]
define	F_XMIN		Memr[$1+2]
define	F_XMAX		Memr[$1+3]
define	F_YMIN		Memr[$1+4]
define	F_YMAX		Memr[$1+5]
define	F_OPTION	Memi[$1+6]
define	F_LOGFILE	Memi[$1+7]
define	F_XPT		Memi[$1+8]	# pointer to X values
define	F_YPT		Memi[$1+9]	# pointer to Y values
define	F_VPT		Memi[$1+10]	# pointer to flags
define	F_PPT		Memi[$1+11]	# pointer to parameter values
define	F_X		Memr[F_XPT($1) + $2 -1]
define	F_Y		Memr[F_YPT($1) + $2 -1]
define	F_VAR		Memb[F_VPT($1) + $2 -1]		# bool
define	F_PAR		Memr[F_PPT($1) + $2 -1]
# end of ffit.h
