procedure abssenv (intable, outtable, ref_flux)

file intable = ""	{prompt = "input table name"}
file outtable = ""	{prompt = "output table name"}
file ref_flux = ""	{prompt = "reference flux density table name"}

pset cal_tables = ""	{prompt = "Which set of calibration tables are used"}
bool save = no 		{prompt = "save the scratch table? (yes or no)"}
string temp_key = "DET_TEMP"	{prompt = "column name of the temperature"}

string mode = "al"

begin
	file	intbl, outtbl, reftbl, tmptable
	int 	ncols
	int 	rowused

	intbl = intable
	outtbl = outtable
	reftbl = ref_flux

	if (intbl == "") {
	    print ("Error: Input table is empty.")
	    bye ()
	}

	# set up a scratch table
	tmptable = mktemp("abssenv") + ".tab"

	#load table tools
	if (!defpac("ttools")) {
	    print ("The stsdas-ttools package must be loaded.")
	    bye ()
	}

	# expand column size
	tinfo (table = intbl, ttout = no)
	ncols = tinfo.ncols + 14
	rowused = tinfo.rowused + 14
	tchsize (intable = intbl, outtable = tmptable, maxpar = -1, 
		maxcols = ncols, rowlen = rowused, allrows = -1, verbose = no)

	# evaluate calibration corrections
	vevalp (tmptable, cal_tables = cal_tables)

	tcalc (table = tmptable, outcol = "DOBJ_C", equals = \
		"(DOBJ/(1.-DOBJ*DEADTIME)-PREAMP_D-DARK_D)/(HVFACT_D*SENSITIV)",
 		datatype = "real", mode = "h")
	tcalc (table = tmptable, outcol = "DSKY_C", equals = \
	    	"(DSKY/(1.-DSKY*DEADTIME)-PREAMP_D-DARK_D)/(HVFACT_D*SENSITIV)",
 		datatype = "real", mode = "h")

	vasen (intable = tmptable, outtable = outtbl, count_key = "DOBJ_C", 
	    	counterr_key = "DOBJ_ERR", sky_key = "DSKY_C", 
		temp_key = temp_key, ref_flux = reftbl)

	# delete the scratch table
	if (save) {
	    print ("scratch table ", tmptable, " created locally")
	    putlog ("scratch table ", tmptable, " created locally")
	} else {
	    delete (tmptable)
	}
end
