procedure darkv (intable, outtable, type)

file intable = ""	{prompt = "input table name"}
file outtable = ""	{prompt = "output table name"}
string type = "digital"	{prompt = "data type (digital or analog)",
			 enum = "digital|analog"}

pset cal_tables = ""	{prompt = "Which set of calibration tables are used"}
string temp_key = "DET_TEMP"	{prompt = "column name of the temperature"}
bool save = no 		{prompt = "save the scratch table? (yes or no)"}

string mode = "al"

begin
	file	intbl, outtbl, tmptable
	string 	dtype
	int 	ncols
	int 	rowused

	intbl = intable
	outtbl = outtable
	dtype = type

	if (intbl == "") {
	    print ("Error: Input table is empty.")
	    bye ()
	}

	# set up a scratch table
	tmptable = mktemp("darkv") + ".tab"
	
	#load table tools
	if (!defpac("ttools")) {
	    print ("The stsdas-ttools package must be loaded.")
	    bye ()
	}

	# expand column size
	tinfo (table = intbl, ttout = no)
	ncols = tinfo.ncols + 24
	rowused = tinfo.rowused + 24
	tchsize (intable = intbl, outtable = tmptable, maxpar = -1, 
		maxcols = ncols, rowlen = rowused, allrows = -1, verbose = no)

	# evaluate calibration corrections
	vevalp (tmptable, cal_tables = cal_tables)

	# calculate dark count
	vdark (intable = tmptable, outtable = outtbl, temp_key = temp_key, 
		type = dtype)

	# delete scratch tables
	if (save) {
	    print ("scratch table ", tmptable, " created locally")
	    putlog ("scratch table ", tmptable, " created locally")
	} else {
	    delete (tmptable)
	}
end
