procedure deadtimev (intable, outtable)

file intable = ""	{prompt = "input table name"}
file outtable = ""	{prompt = "output table name"}

real xweight = -2.	{prompt = "weighting scheme of analog count rate"}
real yweight = -2.	{prompt = "weighting scheme of digital count rate"}

int itermax = 100	{prompt = "maximum number of least square iteration",
				 min = 1}
real tolerance = 1.e-12	{prompt = "tolerance of sigma-squared convergence",
				 min = 0, max = 1}
real fraction = .5	{prompt = "specified fraction applied to coefficients\n\
  modification", min = 0, max = 1}

pset cal_tables = ""	{prompt = "Which set of calibration tables are used"}
bool save = no 		{prompt = "save the scratch table? (yes or no)"}

string mode = "al"

begin
	string intbl, outtbl, tmptable
	int ncols
	int rowused

	intbl = intable
	outtbl = outtable

	if (intbl == "") {
	    print ("Error: Input table is empty.")
	    bye ()
	}

	# set up an intermediate file, tmptable
	tmptable = mktemp("deadtimev") + ".tab"

	#load table tools
	if (!defpac("ttools")) {
	    print ("The stsdas-ttools package must be loaded.")
	    bye ()
	}

	# expand the column size
	tinfo (table = intbl, ttout = no)
	ncols = tinfo.ncols + 24
	rowused = tinfo.rowused + 24
	tchsize (intable = intbl, outtable = tmptable, maxpar = -1, 
		maxcols = ncols, 
	rowlen = rowused, allrows = -1, verbose = no)

	# evaluate calibration corrections
	vevalp (tmptable, cal_tables = cal_tables)

	# do the dead time fitting
	vdt (intable = tmptable, outtable = outtbl, itermax = itermax, 
		tolern = tolerance, frac = fraction, xweight = xweight, 
		yweight = yweight)

	# delete the scratch table
	if (save) {
	    print ("scratch table ", tmptable, " created locally")
	    putlog ("scratch table ", tmptable, " created locally")
	} else {
	    delete (tmptable)
	}
end
