procedure gainfac (intable, outtable, setting, refhv)

file intable = ""	{prompt = "input table name"}
file outtable = ""	{prompt = "output table name"}
string setting = "high"	{prompt = "gain setting level (high or low)",
				 enum = "high|low"}
file refhv = ""		{prompt = "reference high voltage table name"}

pset cal_tables = ""	{prompt = "Which set of calibration tables are used"}
bool save = no 		{prompt = "save the scratch table? (yes or no)"}
string temp_key = "DEA_TEMP"	{prompt = "column name of the temperature"}

string mode = "al"

begin
	file	intbl, outtbl, reftbl, tmptable
	string 	level
	int 	ncols
	int 	rowused

	intbl = intable
	outtbl = outtable
	level = setting
	reftbl = refhv

	if (intbl == "") {
	    print ("Error: Input table is empty.")
	    bye ()
	}

	tmptable = mktemp("gainfac") + ".tab"

	#load table tools
	if (!defpac("ttools")) {
	    print ("The stsdas-ttools package must be loaded.")
	    bye ()
	}

	# expand column size
	tinfo (table = intbl, ttout = no)
	ncols = tinfo.ncols + 24
	rowused = tinfo.rowused + 24
	tchsize (intable = intbl, outtable = tmptable, maxpar = -1, 
		maxcols = ncols, rowlen = rowused, allrows = -1, verbose = no)
	
	# evaluate calibration corrections
	vevalp (tmptable, cal_tables = cal_tables)
	
	# gain factor calculation
	vgnfac (intable = tmptable, outtable = outtbl, setting = level, 
        	temp_key = temp_key, refhv = reftbl)
	
	# delete the scratch table
	if (save) {
	    print ("scratch table ", tmptable, " created locally")
	    putlog ("scratch table ", tmptable, " created locally")
	} else {
	    delete (tmptable)
	}
end
