        SUBROUTINE CDERFD (
*
*  inputs
*
     :                  X,
*
*  outputs
*
     :                  ERF, STATUS)
*
*  Module number:
*
*  Module name:
*
*  Keyphrase:
*  ----------
*  calculate the error function
*
*  Description:
*  ------------
*  adapted from Numerical Recipes by William Press et. al., p. 164,
*  subroutine ERF
*  Double precision version
*
*  FORTRAN name: CDERFD.FOR
*
*  Keywords of accessed files and tables:
*  --------------------------------------
*  Name                         I/O     Description / Comments
*
*  Subroutines Called:
*  -------------------
*  CDBS:
*       CDGAMD
*  SDAS:
*       None
*  Others:
*       None
*
*  History:
*  --------
*  Version      Date        Author          Description
*     1       11-11-88     J.-C. HSU        coding
*
*-------------------------------------------------------------------------------
*
*== input:
*                                       --argument of the error function
        DOUBLE PRECISION        X
*
*== output:
*                                       --functional value
        DOUBLE PRECISION        ERF
*                                       --error status
        INTEGER                 STATUS
*------------------------------------------------------------------------------
*
        IF (X .LT. 0.D0) THEN
            CALL CDGAMD (0.5D0, X**2,     ERF, STATUS)
            ERF = - ERF
        ELSE
*
            CALL CDGAMD (0.5D0, X**2,     ERF, STATUS)
        END IF
*
        RETURN
        END
