        FUNCTION CDPINN (
*
*  inputs
*
     :                  A, B, WEIGHT, NPTS)
*
*  Module number:
*
*  Module name:
*
*  Keyphrase:
*  ----------
*  calculates (weighted) inner product of two quantities (arrays)
*
*  Description:
*  ------------
*
*  FORTRAN name: CDPINN
*
*  Keywords of accessed files and tables:
*  --------------------------------------
*  Name                         I/O     Description / Comments
*       None
*
*  Subroutines Called:
*  -------------------
*  CDBS:
*       None
*  SDAS:
*       None
*  Others:
*       None
*
*  History:
*  --------
*  Version      Date        Author          Description
*     1       12-01-87     J.-C. HSU        design and coding
*-------------------------------------------------------------------------------
*
*== input:
*                                       --the two quantities to have inner
*                                       --product
        DOUBLE PRECISION        A(1), B(1),
*                                       --weights
     :                          WEIGHT(1)
*                                       --number of data points
        INTEGER                 NPTS
*
*== output:
*                                       --the inner product
        DOUBLE PRECISION        CDPINN
*
*== local:
*                                       --loop index
        INTEGER                 I
*------------------------------------------------------------------------------
*
        CDPINN = 0.D0
*
        DO 10 I = 1, NPTS
            CDPINN = CDPINN + A(I) * B(I) * WEIGHT(I)
   10   CONTINUE
*
        RETURN
        END
