        SUBROUTINE VASIZE (
*
*  inputs:
*
     :                  OBSID, APERT, APNAME, AREA0, NAREA,
*
*  outputs:
*
     :                  AREA, STATUS)
*
*  Module Number:
*
*  Module Name: CALHSP
*
*  Keyphrase:
*  ----------
*  Read aperture size
*
*  Description:
*  ------------
*
*  FORTRAN Name: VASIZE.FOR
*
*  Keywords of Accessed Files and Tables:
*  --------------------------------------
*  Name                         I/O     Description / Comments
*
*  Subroutines Called:
*  -------------------
*  CDBS:
*       None
*  SDAS:
*       UMSPUT
*  OTHERS:
*       None
*
*  History:
*  --------
*  Version      Date        Author          Description
*     1       07-21-89     J.-C. Hsu        Design and coding (separate from VSNEVL)
*-------------------------------------------------------------------------------
*
*== inputs:
*                                       --number of rows in the aperture area table
        INTEGER                 NAREA
*                                       --observation ID
        CHARACTER*(*)           OBSID,
*                                       --aperture ID of input data
     :                          APERT,
*                                       --aperture name in the aperture area table
     :                          APNAME(1)
*					--aperture area in the aperture area table
        REAL                    AREA0(1)
*
*==outputs:
*                                       --aperture area
        REAL                    AREA
*                                       --error status
        INTEGER                 STATUS
*
*==local:
*                                       --loop indices
        INTEGER                 K,
*                                       --error status
     :                          STATOK
*                                       --error message context
        CHARACTER*130           CONTXT, MESS
*=========================begin hsp.inc=========================================
*                                       --status return code
        INTEGER         OK, ERRNUM(20)
        INTEGER         DEST, PRIO
        DATA OK /0/
        DATA ERRNUM /701, 702, 703, 704, 705, 706, 707, 708, 709, 710,
     :               711, 712, 713, 714, 715, 716, 717, 718, 719, 720/
*                                       --message destination and priority
        DATA DEST, PRIO /1, 0/
*=========================end hsp.inc===========================================
*-------------------------------------------------------------------------------
*
*  find aperture area from the aperture area table
*
        DO 10 K = 1, NAREA
            IF (APERT(1:10) .EQ. APNAME(K)(1:10)) GO TO 20
   10   CONTINUE
*
        STATUS = ERRNUM(1)
        CONTXT = APERT // ' not found in aperture area table' 
        GO TO 999
   20   AREA = AREA0(K)
*
        STATUS = OK
        GO TO 1000
*
*  write error message
*
  999   MESS = OBSID // '  VASIZE: ' // CONTXT
        CALL UMSPUT (MESS, DEST, PRIO,      STATOK)
*
 1000   RETURN
        END
