include	"vpthit.h"

#  vpt_in -- Read parameters for the task vpthit
#
#  Description:
#  ------------
#  Read CL parameters and do necessary checking and conversions.
#  
#  Input CL parameters:
#  -----------------
#  "infile"		Input science data file template name
#  "outfile"		Output file template name
#  "outtable"		Output table name
#  "scheme"		method used to remove particle events
#  "sigmas"		statistical criterion for removing particle events
#  "dthresh"		digital threshold of removing particle events
#  "athresh"		analog threshold of removing particle events
#  "hitval"		mask value of particle events in the output mask file
#  "lowflag"		remove low points too?
#
#  Date		Author			Description
#  ----		------			-----------
#  29-Oct-1990  J.-C. Hsu		rewrite in SPP
#------------------------------------------------------------------------------

procedure vpt_in (fin, outfile, outtbl, scheme, sigmas, dthresh, athresh, 
			hitval, lowflag)

pointer	fin	 		# output: input file template pointer
char	outfile[SZ_FNAME], outtbl[SZ_FNAME], scheme[SZ_SCHEME]
real	sigmas, dthresh, athresh, hitval
bool	lowflag

pointer	imtopenp() 
real	clgetr()
bool	clgetb()
#==============================================================================
begin
	# open file templates 
	fin = imtopenp ("infile")

	# read other CL parameters
	call clgstr ("outfile", outfile, SZ_FNAME)
	call clgstr ("outtable", outtbl, SZ_FNAME)
	call clgstr ("scheme", scheme, SZ_SCHEME)
        sigmas = clgetr ("sigmas")
        dthresh = clgetr ("dthresh")
        athresh = clgetr ("athresh")
        hitval = clgetr ("hitval")
	lowflag	= clgetb ("lowflag")
end
