# rastoim.h
# Rasterfile header structure
# From /usr/include/rasterfile.h

define	SZ_RASHEAD	8
define	RAS_MAGIC	(Memi[$1+0])	# Magic number
define	RAS_WIDTH	(Memi[$1+1])	# Image width (pixels per line)
define	RAS_HEIGHT	(Memi[$1+2])	# Image height (number of lines)
define	RAS_DEPTH	(Memi[$1+3])	# Image depth (bits per pixel)
define	RAS_LENGTH	(Memi[$1+4])	# Image length (bytes)
define	RAS_TYPE	(Memi[$1+5])	# File type
define	RAS_MAPTYPE	(Memi[$1+6])	# Colormap type
define	RAS_MAPLENGTH	(Memi[$1+7])	# Colormap length (bytes)

# Rasterfile magic number
define	RF_MAGIC_NUM	59A66A95X

#	/* Sun supported ras_type's */
define	RT_OLD		0	#/* Raw pixrect image in 68000 byte order */
define	RT_STANDARD	1	#/* Raw pixrect image in 68000 byte order */
define	RT_BYTE_ENCODED	2	#/* Run-length compression of bytes */
define	RT_FORMAT_RGB	3	#/* XRGB or RGB instead of XBGR or BGR */
define	RT_FORMAT_TIFF	4	#/* tiff <-> standard rasterfile */
define	RT_FORMAT_IFF	5	#/* iff (TAAC format) <-> standard rasterfile */
define	RT_EXPERIMENTAL	65535	#/* Reserved for testing */

#	/* Sun registered ras_maptype's */
define	RMT_RAW		2

#	/* Sun supported ras_maptype's */
define	RMT_NONE	0	#/* ras_maplength is expected to be 0 */
define	RMT_EQUAL_RGB	1	#/* red[ras_maplength/3],green[],blue[] */

define	OUTCM_SIZE	256	# Output colormap length
define	CMAP_MAX	255	# Maximum map value

define	NTSC_RED_F	.299
define	NTSC_GRN_F	.587
define	NTSC_BLU_F	.114
