procedure saodump ()

#  saodump -- Make an image from the display buffer (not specific to
#  SAOimage) and an SAOimage color map.

#  26 February 1992 ZGL
#  17 March 1992  Added code to plot colormap using igi  ZGL
#  6 November 1992  Added call to fixicm to kludge color map and image
#                   for celco.  ZGL
#  3 December  Extract pltcmap as a script task.  ZGL
#  7 December  Fixed stupid bugs introduced last time.  ZGL


file	saocmap	{prompt = "Input SAOimage color map"}
file	image	{"saodump.hhh", prompt = "Dumped image"}
file	cmapimg	{"cmap.hhh", prompt = "Dumped color map"}
bool	doplot	{no, prompt = "Plot color map?"}
string	device	{"stdgraph", prompt="Graphics device"}

begin
	file iscm
	file iimg
	file icmf
	file igicmd

	#  Assign local variables
	iscm = saocmap
	iimg = image

#	print ("Input SAOimage color map: ", iscm)
#	print ("Dumped image: ", iimg)
#	print ("Dumped color map: ", icmf)

	if (iimg != "") {
	    #  Dump the image buffer
	    print ("Dumping the display buffer")
	    dsimg (1, iimg)
	}

	if (iscm != "") {
	    # Reformat the color map
	    if (!access (iscm))
		error (11, "Color map file not found")

	    print ("Reformatting the color map")
	    icmf = cmapimg
	    if (icmf == "") {
		icmf = iscm + ".hhh"
		print ("into: ", icmf)
	    }

	    # Format the colormap
	    scmapc (iscm, icmf, fullrange = no, listmap = no, debug = 0)

	    if (iimg != "") {
		# Kludge the image and color map to work properly with celco
		fixicm (iimg, icmf)
	    }

	    if (doplot) {
		# Plot the color map
		print ("Plotting")

		pltcmap (cmapimg, device=device, fullrange=no, prtigi=no)
	    }
	}
end
