# MODEONE -- Restore FOS mode I images
#--
procedure modeone(in, outy, outx)

file     in = ""   {prompt = ">input image name"}
file     outy = ""  {prompt = ">output image name for y restoration"}
file     outx = ""  {prompt = ">output image name for x and y restoration"}

begin

file    file1, file2, file3, temp, lab1, lab2, lab3
int	len, iext

	# check for needed packages
	if (!defpac ("tv") || !defpac ("stplot") || !defpac("tools") ) 
	    error (0, "Be certain that the tv, stplot, and tools packages are loaded")

        file1 = in
        file2 = outy
        file3 = outx

	lab1 = mktemp ("tmp$modeone_1_")
	lab2 = mktemp ("tmp$modeone_2_")
	lab3 = mktemp ("tmp$modeone_3_")

	# do the image restoration
	tarestore (file1,output_y=file2,output_x=file3,
	    label1=lab1,label2=lab2,label3=lab3)
	
	# display the images

	# if input images is not a 2-d image build one
	# assume this happens in case of .c1h files only
	len = strlen (file1)
	for (i = 1; i <= len-3; i += 1) {
	    if (substr (file1, i, i+3) == ".c1h") { 
	    	temp = mktemp("tmp$modeone")

	    	# build a 2-D image
	    	grlist (image=file1, members="-") | 
	        	stack(input="@STDIN",output=temp)

	    	file1 = temp
	        break
	    }
	} 
	
	file1 = file1 + '[-*,*]'
	file2 = file2 + '[-*,*]'
	file3 = file3 + '[-*,*]'

        # display raw image
        display (file1,1,erase+,border_erase-,select_frame+,zscale-,
                 repeat-,fill+,xcenter=0.5,ycenter=0.5,xsize=0.67,
                 ysize=0.67,xmag=1.0,ymag=1.0)
        tvmark (1,coords="",nxoffset=0,nyoffset=0,color=203,
                commands=lab1)

	sleep 10

        # display the y-restored image
        display (file2,2,erase+,border_erase-,select_frame+,zscale-,
                 repeat-,fill+,xcenter=0.5,ycenter=0.5,xsize=0.67,
                 ysize=0.67,xmag=1.0,ymag=1.0)
        tvmark (2,coords="",nxoffset=0,nyoffset=0,color=203,
                commands=lab2)

	sleep 10

        # display the x-restored image
        display (file3,3,erase+,border_erase-,select_frame+,zscale-,
                 repeat-,fill+,xcenter=0.5,ycenter=0.5,xsize=0.67,
                 ysize=0.67,xmag=1.0,ymag=1.0)
        tvmark (3,coords="",nxoffset=0,nyoffset=0,color=203,
                commands=lab3)

end
