# OVERSCAN -- Simulate the effects of overscanning in a one-dimensional image
#
# This task simulates the effects of overscanning in a spectrum. Each portion 
# of the spectrum is reduced at points closer to either end of the portion
# than overscan by multiplying by a factor of (dist/overscan), where dist
# is the distance to the closer end of the portion.
#
# B.Simon	01-Jun-87	Original

procedure overscan()

#--
char	image[SZ_FNAME]		# Name of the image that will be modified
int	scan			# Number of image steps that are overscanned
int	xsteps			# X stepping factor of the image
int	ysteps			# Y stepping factor of the image

char	im_list[SZ_LINE]
int	im_num
pointer	im_ptr

bool	tp_fetch()
int	clgeti()
pointer	tp_open() 

begin
	# Read the task parameters

	call clgstr ("image", im_list, SZ_LINE)
	scan = clgeti("overscan")
	xsteps = clgeti("xsteps")
	ysteps = clgeti("ysteps")

	# Expand the image template into a list of images, each with one
	# group.
                                       
	im_ptr = tp_open (im_list, 0, im_num)

	while (tp_fetch (im_ptr,image))
	    call fixgrp (image, scan, xsteps, ysteps)

	# Close image list and exit

	call tp_close(im_ptr)

end
