# SORTD_INDEX -- sort a double precision array arrin of length n into ascending 
# numerical order using the Heapsort algorithm, while making the corresponding 
# rearrangement of the index array indx.
# Adapted from the routine INDEXX in Numerical Recipes by W. H. Press et. al. 
# 1986, page 233.
#------------------------------------------------------------------------------

procedure sortd_index (arrin, indx, n)

double	arrin[n]	#input/output: array to be sorted
int	indx[n]		#output: index array to be sorted
int	n		#input: number of points in the aarrays

double	q		#buffer
int	i, j, k		
int	ir, indxt
#==============================================================================
begin
	# initialize the index array with consecutive integers.
	do i = 1, n
	    indx[i] = i
	if (n < 2) 		# if less than two points no need to go on
	    return

	k = n/2 + 1
	ir = n

	repeat {
	    if (k > 1) {
		k = k - 1
		indxt = indx[k]
		q = arrin[indxt]
	    }
	    else {	
		indxt = indx[ir]
		q = arrin[indxt]	
		indx[ir] = indx[1]		
		ir = ir - 1		
		if (ir == 1) {		
		    indx[1] = indxt	
		    return
		}
	    }
	    i = k
	    j = k + k

	    while (j <= ir) {
		if (j < ir) {
		    if (arrin[indx[j]] < arrin[indx[j+1]]) 	
			j = j + 1	
		}
		if (q < arrin[indx[j]]) {		
		    indx[i] = indx[j]
		    i = j
		    j = j + j
		} else
		    j = ir + 1
	    }
	    indx[i] = indxt			
	}
end
