include	"polarimetry.h"

#  GET_PAOFFSET -- acquire the position angle offset
#
#  Description:
#  ------------
#  Racquire the position angle offset for the input filter
#
#  Date		Author			Description
#  ----		------			-----------
#  21-Jun-1990	J.-C. Hsu		design and coding
#------------------------------------------------------------------------------

procedure get_paoffset (filter, filter_paoffset, paoffset, paoffset_err, 
			npts_paoffset, pa0, pa0_err)

char	filter[SZ_FILTER]	
			# input: filter name
char	filter_paoffset[SZ_FILTER, npts_paoffset]
			# input: filter names in the p.a. offset table
real	paoffset[npts_paoffset]	
			# input: tabulated position angle offsets
real	paoffset_err[npts_paoffset]	
			# input: tabulated position angle offsets' errors
int	npts_paoffset	# input: number of rows in position angle offsets table

real	pa0		# output: position angle offset for the input filter 
real	pa0_err		# output: pa0's error

int	i

int	strmatch()
#==============================================================================
begin

	do i = 1, npts_paoffset {
	    if (strmatch (filter_paoffset[1, i], filter) != 0) {
		pa0 = paoffset[i]
		pa0_err = paoffset_err[i]
		return
	    }
	}

	# issue error message if no match
	call error (1, 
	    "filter name is not found in the position angle offset table")

end
