include	"polarimetry.h"

#  GET_POLEFF -- acquire the polarizaion efficiency 
#
#  Description:
#  ------------
#  Racquire the polarizaion efficiency for the input aperture
#
#  Date		Author			Description
#  ----		------			-----------
#  21-Jun-1990	J.-C. Hsu		design and coding
#------------------------------------------------------------------------------

procedure get_poleff (aper, aper_poleff, poleff, poleff_err, npts_poleff,
			peff, peff_err)

char	aper[SZ_APER]	# input: aperture name
char	aper_poleff[SZ_APER, npts_poleff]
			# input: aperture names in the pol. efficiency table
real	poleff[npts_poleff]	
			# input: tabulated polarization efficiencies
real	poleff_err[npts_poleff]	
			# input: tabulated polarization efficiencies' errors
int	npts_poleff	# input: number of rows in polarization efficiency table

real	peff		# output: polarization efficiency for the input aperture
real	peff_err	# output: peff's error

int	i

int	strmatch()
#==============================================================================
begin

	do i = 1, npts_poleff {
	    if (strmatch (aper_poleff[1, i], aper) != 0) {
		peff = poleff[i]
		peff_err = poleff_err[i]
		return
	    }
	}

	# issue error message if no match
	call error (1, 
	    "aperture name is not found in the polarization efficiency table")

end
