# CDPBAS -- convert from orthogonal polynomial basis to 1, x, x**2,...
#
#  date		author		description
#  12-01-87	J.-C. Hsu	design and coding
#  03-09-90	J.-C. Hsu	rewrite in SPP
#-------------------------------------------------------------------------------

procedure cdpbas (a, sig, order, ortho,   coeff)

int	order		# order of polynomial
double 	a[0:order] 	# orthogonal polynomial coefficients
double	sig[0:order]	# a's standard deviation
double	ortho[0:order, 0:order]	
			# input: orthogonal polynomial construct
double 	coeff[0:order] 
			# output: regular polynomial coefficients 

int	i, k  		# loop index
#------------------------------------------------------------------------------
begin
	#  first calculate coefficients
        do i = 0, order
            coeff[i] = a[i]

        do i = order, 1, -1 {
            do k = i-1, 0, -1
                coeff[k] = coeff[k] + coeff[i] * ortho[k, i]
	}

end
