# POLYVAL -- evaluate a polynomial at x
#
#  Description:
#  ------------
#  calculate y = a0 + a1 * x + a2 * x^2 + a3 * x^3 + ...
#
#  date		author		description
#  03-22-90	J.-C. Hsu	original
#-------------------------------------------------------------------------------

double procedure polyval (x, a, order)

double	x		# input: independent variable
int	order		# input: order of polynomial
double 	a[0:order] 	# input: regular polynomial coefficients 

double	y
int	i  		# loop index
#------------------------------------------------------------------------------
begin
	y = a[order]
	do i = order, 1, -1
	    y = y * x + a[i-1]

	return (y)

end
