        SUBROUTINE YCCORP(NWAVE,WAVE,SAPPX,SEXACT,INTE)
*
* Module Number: 14.8.2.3
*
* Module Name: YCCORP
*
* Keyphrase:
* ----------
*       Print cross correlation results
*
* Description:
* ------------
*       This routine prints the results of the cross correlation routine
*       ycrosscor
*
* Fortran Name: YCCORP.for
*
* Keywords of accessed files and tables:
* --------------------------------------
*       none
*
* Subroutines Called:
* -------------------
* CDBS:
*       none
* SDAS:
*       umsput
*
* History:
* --------
* version         date            Author          Description
*    1          3/23/87         D. Lindler      Designed and coded
*    2          JAN 88          D. LINDLER      New sdas i/o and standards
*-------------------------------------------------------------------------
C     INCLUDE FILE FOR THE IRAF77 FORTRAN INTERFACE TO THE IRAF VOS
C
C
C     FILE I/O ACCESS MODES
C
      INTEGER   RDONLY
      PARAMETER (RDONLY = 1)
      INTEGER   RDWRIT
      PARAMETER (RDWRIT = 2)
      INTEGER   WRONLY
      PARAMETER (WRONLY = 3)
      INTEGER   APPEND
      PARAMETER (APPEND = 4)
C
C     CODES FOR DATA TYPES
C
      INTEGER   TYBOOL
      PARAMETER (TYBOOL = 1)
      INTEGER   TYCHAR
      PARAMETER (TYCHAR = 2)
      INTEGER   TYINT
      PARAMETER (TYINT = 4)
      INTEGER   TYREAL
      PARAMETER (TYREAL = 6)
      INTEGER   TYDOUB
      PARAMETER (TYDOUB = 7)
C
C     UMSPUT DESTINATIONS -- CB, DAO, 4-SEP-87
C
      INTEGER STDOUT
      PARAMETER (STDOUT = 1)
      INTEGER STDERR
      PARAMETER (STDERR = 2)
      INTEGER USRLOG
      PARAMETER (USRLOG = 4)
C
C     UHDAS HEADER PARM TYPES -- CB, DAO, 5-SEP-87
C
      INTEGER GENHDR
      PARAMETER (GENHDR = 0)
      INTEGER IMSPEC
      PARAMETER (IMSPEC = 1)
C
C     THIS SECTION IS FOR PARAMETERS RELEVANT TO TABLE I/O.
C
C     THESE MAY BE SET BY UTPPTI AND/OR READ BY UTPGTI:
C
C                                       LENGTH OF ROW (UNIT = SIZE OF REAL)
      INTEGER   TBRLEN
      PARAMETER (TBRLEN = 1)
C                                       INCREASE ROW LENGTH
      INTEGER   TBIRLN
      PARAMETER (TBIRLN = 2)
C                                       NUMBER OF ROWS TO ALLOCATE
      INTEGER   TBALLR
      PARAMETER (TBALLR = 3)
C                                       INCREASE ALLOC NUM OF ROWS
      INTEGER   TBIALR
      PARAMETER (TBIALR = 4)
C                                       WHICH TYPE OF TABLE? (ROW OR COLUMN)
      INTEGER   TBWTYP
      PARAMETER (TBWTYP = 5)
C                                       MAXIMUM NUMBER OF USER PARAMETERS
      INTEGER   TBMXPR
      PARAMETER (TBMXPR = 6)
C                                       MAXIMUM NUMBER OF COLUMNS
      INTEGER   TBMXCL
      PARAMETER (TBMXCL = 7)
C                                       TYPE = ROW-ORDERED TABLE
      INTEGER   TBTYPR
      PARAMETER (TBTYPR = 11)
C                                       TYPE = COLUMN-ORDERED TABLE
      INTEGER   TBTYPC
      PARAMETER (TBTYPC = 12)
C
C     THESE MAY BE READ BY UTPGTI BUT MAY NOT BE SET:
C
C                                       NUMBER OF ROWS WRITTEN TO
      INTEGER   TBNROW
      PARAMETER (TBNROW = 21)
C
C     END IRAF77.INC
C
C INPUT PARAMETERS:
C
        INTEGER         NWAVE
C                                    ---> number of spectral lines
        DOUBLE PRECISION WAVE(NWAVE)
C                                    ---> wavelength vector
        DOUBLE PRECISION SAPPX(NWAVE)
C                                    ---> approximate sample positions
        DOUBLE PRECISION SEXACT(NWAVE)
C                                    ---> positions found by CROSSCOR
        DOUBLE PRECISION INTE(1)
C                                    ---> Peak counts in line
C
C LOCAL VARIABLES
C
        INTEGER         I
C                                    ---> Loop index
        DOUBLE PRECISION DIFF
C                                    ---> approx-exact position
        CHARACTER*130   MESS
C                                    --->MESSAGE
        INTEGER         STATUS
C
C WRITE HEADER LINES
C
        WRITE(MESS,99)
99      FORMAT(' ------Results of cross correlation')
        CALL UMSPUT(MESS,STDOUT,0,STATUS)
        WRITE(MESS,199)
199     FORMAT('   Wavelength    Sapprox    Sexact   Difference',
     *                         '  peak counts')
        CALL UMSPUT(MESS,STDOUT,0,STATUS)
        CALL UMSPUT(' ',STDOUT,0,STATUS)
C
C LOOP ON LINES
C
        DO 100 I=1,NWAVE
                DIFF=SEXACT(I)-SAPPX(I)
                IF(SEXACT(I).EQ. 0.0) THEN
                        WRITE(MESS,299)WAVE(I),SAPPX(I)
                  ELSE
                        WRITE(MESS,299)WAVE(I),SAPPX(I),SEXACT(I),
     *                                          DIFF,INTE(I)
                ENDIF
299             FORMAT(F13.4,3F10.2,F13.0)
                CALL UMSPUT(MESS,STDOUT,0,STATUS)
100     CONTINUE
        RETURN
        END
