        SUBROUTINE YDARK(SUM,NS,NADDS,DARK,STATUS)
C
C Module Number: 14.2.4
C
C Module Name: YDARK
C
C Keyphrase:
C ----------
C Compute FOS dark count
C
C Description:
C ------------
C using the sum of the count rates in multiple frames of data
C the FOS dark count is computed as the average for all frames
C
C
C FORTRAN Name: ydark.for
C
C
C Keywords of Accessed Files :
C --------------------------
C   none
C
C Modules Called:
C ---------------
C SDAS:
C       umsput
C
C History:
C --------
C Version       Date      Author        Description
C   1           9/30/86  D. Lindler     Designed and coded
C   2           Jan 88   D. Lindler     New SDAS I/O and standards
C   2.1         Sep 98   M. De La Pena  Removed dead statements.
C------------------------------------------------------------------------
C     INCLUDE FILE FOR THE IRAF77 FORTRAN INTERFACE TO THE IRAF VOS
C
C
C     FILE I/O ACCESS MODES
C
      INTEGER   RDONLY
      PARAMETER (RDONLY = 1)
      INTEGER   RDWRIT
      PARAMETER (RDWRIT = 2)
      INTEGER   WRONLY
      PARAMETER (WRONLY = 3)
      INTEGER   APPEND
      PARAMETER (APPEND = 4)
C
C     CODES FOR DATA TYPES
C
      INTEGER   TYBOOL
      PARAMETER (TYBOOL = 1)
      INTEGER   TYCHAR
      PARAMETER (TYCHAR = 2)
      INTEGER   TYINT
      PARAMETER (TYINT = 4)
      INTEGER   TYREAL
      PARAMETER (TYREAL = 6)
      INTEGER   TYDOUB
      PARAMETER (TYDOUB = 7)
C
C     UMSPUT DESTINATIONS -- CB, DAO, 4-SEP-87
C
      INTEGER STDOUT
      PARAMETER (STDOUT = 1)
      INTEGER STDERR
      PARAMETER (STDERR = 2)
C
C     UHDAS HEADER PARM TYPES -- CB, DAO, 5-SEP-87
C
      INTEGER GENHDR
      PARAMETER (GENHDR = 0)
      INTEGER IMSPEC
      PARAMETER (IMSPEC = 1)
C
C     THIS SECTION IS FOR PARAMETERS RELEVANT TO TABLE I/O.
C
C     THESE MAY BE SET BY UTPPTI AND/OR READ BY UTPGTI:
C
C                                       LENGTH OF ROW (UNIT = SIZE OF REAL)
      INTEGER   TBRLEN
      PARAMETER (TBRLEN = 1)
C                                       INCREASE ROW LENGTH
      INTEGER   TBIRLN
      PARAMETER (TBIRLN = 2)
C                                       NUMBER OF ROWS TO ALLOCATE
      INTEGER   TBALLR
      PARAMETER (TBALLR = 3)
C                                       INCREASE ALLOC NUM OF ROWS
      INTEGER   TBIALR
      PARAMETER (TBIALR = 4)
C                                       WHICH TYPE OF TABLE? (ROW OR COLUMN)
      INTEGER   TBWTYP
      PARAMETER (TBWTYP = 5)
C                                       MAXIMUM NUMBER OF USER PARAMETERS
      INTEGER   TBMXPR
      PARAMETER (TBMXPR = 6)
C                                       MAXIMUM NUMBER OF COLUMNS
      INTEGER   TBMXCL
      PARAMETER (TBMXCL = 7)
C                                       TYPE = ROW-ORDERED TABLE
      INTEGER   TBTYPR
      PARAMETER (TBTYPR = 11)
C                                       TYPE = COLUMN-ORDERED TABLE
      INTEGER   TBTYPC
      PARAMETER (TBTYPC = 12)
C
C     THESE MAY BE READ BY UTPGTI BUT MAY NOT BE SET:
C
C                                       NUMBER OF ROWS WRITTEN TO
      INTEGER   TBNROW
      PARAMETER (TBNROW = 21)
C
C     END IRAF77.INC
C
C INPUT
C
        REAL            SUM(1)
C                                    --->SUM OF COUNT RATES FOR EACH DIODE
        INTEGER         NS
C                                    --->NUMBER OF DATA POINTS
        INTEGER         NADDS(1)
C                                    --->NUMBER OF ADDS TO EACH POINT IN SUM
C
C OUTPUT
C
        REAL            DARK(1)
C                                    --->DARK COUNT FOR EACH DIODE
        INTEGER         STATUS
C                                    --->WHAT HAPPENED
C
C LOCAL VARIABLES
C
        CHARACTER*130   MESS
        INTEGER         I
C                                    --->INDEX
C
C
C LOOP ON DIODES
C
        DO 10 I=1,NS
                IF(NADDS(I).GT.0.0)THEN
                        DARK(I)=SUM(I)/NADDS(I)
                   ELSE
                        WRITE(MESS,99)I
99                      FORMAT(' NO DARK COUNT COULD',
     *                             ' BE COMPUTED FOR POINT',I5)
                        CALL UMSPUT(MESS,STDOUT,0,STATUS)
                ENDIF
10      CONTINUE
        STATUS=0
1000    RETURN
        END
