#---------------------------------------------------------------------------
.help dst_stat May92 hrs
.ih
NAME
dst_stat -- Calculate statistics on the diode sums.
.endhelp
#---------------------------------------------------------------------------

procedure dst_stat (sum, sumsq, n_data, size_array, mean, sigma)

double  sum[size_array]         # I:  Sums
double  sumsq[size_array]       # I:  Sums squared.
int     n_data[size_array]      # I:  Number of objects summed.
int     size_array              # I:  Size of all the arrays.
double  mean, sigma             # O:  Mean, standard deviation.

# Declarations
int     tot_data                # Total number of objects.

# Function prototypes.
double  asumd()
real    asumi()

begin
        
        tot_data = double (asumi (n_data, size_array))
        mean = asumd (sum, size_array) / tot_data
        sigma = sqrt ((asumd (sumsq, size_array) / tot_data) -
                      (mean * mean))
        
end
#---------------------------------------------------------------------------
# End of dst_stat
#---------------------------------------------------------------------------
