        SUBROUTINE ZFMERG(DVAL,XDEF,DATA,NADDS)
C
C Module Number: 13.3.1.1
C
C Module Name: ZFMERG
C
C Keyphrase:
C ----------
C       merge HRS substepped data
C
C Description:
C ------------
C       An HRS bin of data is merged into a vector of 1/8 stepped
C       data by computed the position in the merged data array
C       as
C               pos = (diode number)*8 + xdef - 1500
C       The data is added to the merged array and the number of
C       adds to each merged data point is accummulated for later
C       Normalization.
C
C FORTRAN Name: ZFMERG.for
C
C
C Keywords of Accessed Files :
C --------------------------
C       none
C
C Modules Called:
C ---------------
C SDAS:
C       umsput
C
C History:
C --------
C Version       Date      Author        Description
C    1          Oct 86  D. Lindler      Designed and coded
C    2          Dec 87  D. Lindler      New SDAS IO/standards
C------------------------------------------------------------------------
C
C INPUT PARAMETERS
C
        DOUBLE PRECISION DVAL(500)
C                                    --->DATA FROM 500 SCIENCE DIODES
        DOUBLE PRECISION XDEF
C                                    --->X-DEFLECTION
C
C INPUT/OUTPUT PARAMETERS
C
        DOUBLE PRECISION DATA(5100)
C                                    --->MERGED DATA ARRAY
        INTEGER         NADDS(5100)
C                                    --->NUMBER OF ADDS TO DATA
C
C LOCAL VARIABLES
C
        INTEGER         I,IPOS
C                                    --->INDICES
C
C------------------------------------------------------------------------
C
C INSERT DATA INTO MERGED ARRAY
C
        DO 10 I=1,500
                IPOS=I*8+XDEF-1500
C                                    --->POSITION IN MERGED ARRAY
                IF((IPOS.GE.1).AND.(IPOS.LE.5100))THEN
                        DATA(IPOS)=DATA(IPOS)+DVAL(I)
                        NADDS(IPOS)=NADDS(IPOS)+1
                ENDIF
10      CONTINUE
        RETURN
        END
