        SUBROUTINE ZOFUNC(C,M,S,AFUNC,N)
*
*  Module number: 13.9.3.2
*
*  Module name: ZOFUNC
*
*  Keyphrase:
*  ----------
*       HRS Wavelength offset function
*  Description:
*  ------------
*       Computes function terms of the wavelength offset
*       equation needed by routine LFIT3
*  FORTRAN name: zofunc
*
*  Keywords of accessed files and tables:
*  --------------------------------------
*       none
*
*  Subroutines Called:
*  -------------------
*       none
*
*
*  History:
*  --------
*  Version      Date        Author          Description
*    1        Oct. 87    D. Lindler     Designed and coded
*-------------------------------------------------------------------------------
C
C INPUT PARAMETERS
C
C       C - CARROUSEL POSITION (REAL*8)
C       M - SPECTRAL ORDER (REAL*8)
C       S - SAMPLER POSITION (REAL*8)
C       N - NUMBER OF COEFFICIENTS (INTEGER)
C
C OUTPUT PARAMETERS
C
C       AFUNC - REAL*8 VECTOR OF FUNCTION VALUES (4 ELEMENTS)
C
C-----------------------------------------------------------------------------
        DOUBLE PRECISION C,M,S,AFUNC(4)
        INTEGER N
C
        AFUNC(1)=1.0
        AFUNC(2)=C
        AFUNC(3)=M
        AFUNC(4)=S
        RETURN
        END
