        SUBROUTINE ZRIP2(M,CARPOS,RATIO,FIT,N,A)
*
*  Module number: 13.12.4
*
*  Module name: zrip2
*
*  Keyphrase:
*  ----------
*       HRS echelle ripple
*  Description:
*  ------------
*       This routine prints the result of the echelle ripple fit
*
*  FORTRAN name: ZRIP2.FOR
*
*  Keywords of accessed files and tables:
*  --------------------------------------
*       NONE
*
*  Subroutines Called:
*  -------------------
*  CDBS:
*
*  SDAS:
*       UMSPUT
*  Others:
*
*
*  History:
*  --------
*  Version      Date        Author          Description
*     1         SEPT 87   D. LINDLER    DESIGNED AND CODED
*-------------------------------------------------------------------------------
C
C INPUT PARAMETERS
C
C       M - VECTOR OF ORDER NUMBERS (INTEGER)
C       CARPOS - VECTOR OF CARROUSEL POSITIONS
C       RATIO - VECTOR OF RAW PROFILE (REAL*8)
C       FIT - VECTOR OF FITTED PROFILE (REAL*8)
C       N - NUMBER OF ELEMENTS IN VECTORS (INTEGER)
C-----------------------------------------------------------------------------
C     INCLUDE FILE FOR THE IRAF77 FORTRAN INTERFACE TO THE IRAF VOS
C
C
C     FILE I/O ACCESS MODES
C
      INTEGER   RDONLY
      PARAMETER (RDONLY = 1)
      INTEGER   RDWRIT
      PARAMETER (RDWRIT = 2)
      INTEGER   WRONLY
      PARAMETER (WRONLY = 3)
      INTEGER   APPEND
      PARAMETER (APPEND = 4)
C
C     CODES FOR DATA TYPES
C
      INTEGER   TYBOOL
      PARAMETER (TYBOOL = 1)
      INTEGER   TYCHAR
      PARAMETER (TYCHAR = 2)
      INTEGER   TYINT
      PARAMETER (TYINT = 4)
      INTEGER   TYREAL
      PARAMETER (TYREAL = 6)
      INTEGER   TYDOUB
      PARAMETER (TYDOUB = 7)
C
C     UMSPUT DESTINATIONS -- CB, DAO, 4-SEP-87
C
      INTEGER STDOUT
      PARAMETER (STDOUT = 1)
      INTEGER STDERR
      PARAMETER (STDERR = 2)
C
C     UHDAS HEADER PARM TYPES -- CB, DAO, 5-SEP-87
C
      INTEGER GENHDR
      PARAMETER (GENHDR = 0)
      INTEGER IMSPEC
      PARAMETER (IMSPEC = 1)
C
C     THIS SECTION IS FOR PARAMETERS RELEVANT TO TABLE I/O.
C
C     THESE MAY BE SET BY UTPPTI AND/OR READ BY UTPGTI:
C
C                                       LENGTH OF ROW (UNIT = SIZE OF REAL)
      INTEGER   TBRLEN
      PARAMETER (TBRLEN = 1)
C                                       INCREASE ROW LENGTH
      INTEGER   TBIRLN
      PARAMETER (TBIRLN = 2)
C                                       NUMBER OF ROWS TO ALLOCATE
      INTEGER   TBALLR
      PARAMETER (TBALLR = 3)
C                                       INCREASE ALLOC NUM OF ROWS
      INTEGER   TBIALR
      PARAMETER (TBIALR = 4)
C                                       WHICH TYPE OF TABLE? (ROW OR COLUMN)
      INTEGER   TBWTYP
      PARAMETER (TBWTYP = 5)
C                                       MAXIMUM NUMBER OF USER PARAMETERS
      INTEGER   TBMXPR
      PARAMETER (TBMXPR = 6)
C                                       MAXIMUM NUMBER OF COLUMNS
      INTEGER   TBMXCL
      PARAMETER (TBMXCL = 7)
C                                       TYPE = ROW-ORDERED TABLE
      INTEGER   TBTYPR
      PARAMETER (TBTYPR = 11)
C                                       TYPE = COLUMN-ORDERED TABLE
      INTEGER   TBTYPC
      PARAMETER (TBTYPC = 12)
C
C     THESE MAY BE READ BY UTPGTI BUT MAY NOT BE SET:
C
C                                       NUMBER OF ROWS WRITTEN TO
      INTEGER   TBNROW
      PARAMETER (TBNROW = 21)
C
C     END IRAF77.INC
        INTEGER M(*),CARPOS(*),N
        DOUBLE PRECISION RATIO(*),FIT(*),A(*)
C
C LOCAL PARAMETERS
C
        DOUBLE PRECISION DIFF
        INTEGER ISTAT,I
        CHARACTER*130 HEADER,MESS
C
C  DATA DECLARATIONS
C
        DATA HEADER/
     *  ' ORDER  CAR. POS.      RAW PROF.        FIT      DIFFERENCE'/
C
C PRINT HEADING
C
        CALL UMSPUT(HEADER,STDOUT,0,ISTAT)
        CALL UMSPUT('    ',STDOUT,0,ISTAT)
C
C LOOP ON ELEMENTS
C
        DO 100 I=1,N
                DIFF=RATIO(I)-FIT(I)
                WRITE(MESS,99)M(I),CARPOS(I),RATIO(I),FIT(I),DIFF
99              FORMAT(I5,I10,3F15.7)
                CALL UMSPUT(MESS,STDOUT,0,ISTAT)
100     CONTINUE
C
C PRINT COEFFICIENTS OF FIT
C
        CALL UMSPUT(' ',STDOUT,0,ISTAT)
        CALL UMSPUT(' COEFFICIENTS OF FIT',STDOUT,0,ISTAT)
        WRITE(MESS,199) A(1),A(2)
199     FORMAT('       a=',F12.8,'       b=',F12.8)
        CALL UMSPUT(MESS,STDOUT,0,ISTAT)
        RETURN
        END
