procedure side1_czscoffc (input, output)

file	input {prompt="GHRS czscoffc reference table to modify"}
file	output {prompt="Modified output table"}
int	offset {10936,prompt="Carrousel offset between side 1 and side 2"}

bool	verbose {yes,prompt="Print informational messages"}
string	Version {"1Sep95",prompt="Date of Installation"}

begin
	# Declarations.
	int	alen, glen
	string	aper, apertures, taper, raper
	real	cs0, cs1, cs2, cs3, cs4, cs5
	string	grat, gratings
	int	i
	int	min_carpos, max_carpos
	int	min_sporder, max_sporder
	int	poffset
	file	poutput
	int	r, nrows, newr
	string	sx, sy
	real	x

	apertures = "SC1 SC2"
	alen = strlen (apertures)
	
	gratings = "ECH-A G140M G140L"
	glen = strlen (gratings)

	# Get interactive parameters.
	poutput = output
	poffset = offset

	# Copy input to output.
	tcopy (input, poutput, verbose=no)
	tinfo (poutput, ttout=no)
	nrows = tinfo.nrows
	newr = nrows + 1

	# For each grating, modify the table.
	while (fscan (gratings, grat) != EOF) {
	    taper = apertures
	    while (fscan (taper,aper) != EOF) {
		for (r = 1; r <= nrows; r = r + 1) {

		    # Check for grating and aperture.
		    tabpar (poutput, "grating", r)
		    if (tabpar.value != grat)
			next
		    tabpar (poutput, "aperture", r)
		    if (tabpar.value != aper)
			next

		    # Get other column information.
		    tabpar (poutput, "ref_aperture", r)
		    raper = tabpar.value
		    tabpar (poutput, "min_carpos", r)
		    min_carpos = int (tabpar.value)
		    tabpar (poutput, "max_carpos", r)
		    max_carpos = int (tabpar.value)
		    tabpar (poutput, "min_sporder", r)
		    min_sporder = int (tabpar.value)
		    tabpar (poutput, "max_sporder", r)
		    max_sporder = int (tabpar.value)
		    tabpar (poutput, "cs0", r)
		    cs0 = real (tabpar.value)
		    tabpar (poutput, "cs1", r)
		    cs1 = real (tabpar.value)
		    tabpar (poutput, "cs2", r)
		    cs2 = real (tabpar.value)
		    tabpar (poutput, "cs3", r)
		    cs3 = real (tabpar.value)
		    tabpar (poutput, "cs4", r)
		    cs4 = real (tabpar.value)
		    tabpar (poutput, "cs5", r)
		    cs5 = real (tabpar.value)

		    # Create a new row.
		    partab (grat, poutput, "grating", newr)
		    partab (raper, poutput, "ref_aperture", newr)
		    partab (aper, poutput, "aperture", newr)
		    i = min_carpos + poffset
		    partab (i, poutput, "min_carpos", newr)
		    i = max_carpos + poffset
		    partab (i, poutput, "max_carpos", newr)
		    partab (min_sporder, poutput, "min_sporder", newr)
		    partab (max_sporder, poutput, "max_sporder", newr)

		    x = cs0 - (cs1 * poffset) + (cs4 * poffset * poffset)
		    partab (x, poutput, "cs0", newr)
		    x = cs1 - (2 * cs4 * poffset)
		    partab (x, poutput, "cs1", newr)
		    x = cs2 - (cs3 * poffset)
		    partab (x, poutput, "cs2", newr)
		    partab (cs3, poutput, "cs3", newr)
		    partab (cs4, poutput, "cs4", newr)
		    partab (cs5, poutput, "cs5", newr)

		    # Write out comment.
		    time | scan (sx, sx, sy)
		    partab ("Offset: "//poffset//" "//sy, poutput,
			    "remarks", newr)

		    newr = newr+1
		}
		

		# Get next aperture.
		i = stridx (" ", taper)
		if (i == 0)
		    break
		taper = substr (taper, i+1, alen)
	    }

	    # Get next grating.
	    i = stridx (" ", gratings)
	    if (i == 0)
		break
	    gratings = substr (gratings, i+1, glen)
	}
end
