procedure side1_offset_rc (input, output, offset)

file	input	{prompt="CCRC table to modify"}
file	output	{prompt="Modified output table"}
real	offset	{10936,prompt="Carrousel offset between side 1 and side 2"}
bool	verbose	{yes,prompt="Print informational messages"}
string	Version	{"1Sep95",prompt="Date of Installation"}

begin
	file	pinput
	real	poffset
	file	poutput
	string	select
	file	troot
	file	t_mod
        file	t_stable
	string	un_select
	
	# Get input parameters.
	pinput = input
	poutput = output
	poffset = offset

        # If no input, just exit
        if (pinput == "") {
            if (verbose)
                print ("side1_offset_rc: No input specified.")
            bye
        }
        
	if (verbose)
	    print ("side1_offset_rc: "//pinput//"-->"//poutput)
        
        # Create temporary names
        troot = mktemp ("tmp$s1orc")
        t_mod = troot//"_mod"
	t_stable = troot//"_stable"

        # The row selection criterion
        select = "(grating==\"ECH-A\")|(grating==\"G140M\")|(grating==\"G140L\")"
        un_select = "(grating!=\"ECH-A\")&(grating!=\"G140M\")&(grating!=\"G140L\")"

        # Get a table containing just the affected rows.
        tselect (pinput, t_mod, select)

        # Modify the appropriate columns.
        tcalc (t_mod, "f00",
               "f00-(f01*"//poffset//")+(f02*("//poffset//"**2))",
               datatype="double", colunits="", colfmt="")
        tcalc (t_mod, "f01",
               "f01 - (2*f02*"//poffset//")",
               datatype="double", colunits="", colfmt="")

        tcalc (t_mod, "f10",
               "f10-(f11*"//poffset//")+(f12*("//poffset//"**2))",
               datatype="double", colunits="", colfmt="")
        tcalc (t_mod, "f11",
               "f11 - (2*f12*"//poffset//")",
               datatype="double", colunits="", colfmt="")

        tcalc (t_mod, "f20",
               "f20-(f21*"//poffset//")+(f22*("//poffset//"**2))",
               datatype="double", colunits="", colfmt="")
        tcalc (t_mod, "f21",
               "f21 - (2*f22*"//poffset//")",
               datatype="double", colunits="", colfmt="")

        tcalc (t_mod, "f30",
               "f30-(f31*"//poffset//")+(f32*("//poffset//"**2))",
               datatype="double", colunits="", colfmt="")
        tcalc (t_mod, "f31",
               "f31 - (2*f32*"//poffset//")",
               datatype="double", colunits="", colfmt="")

        tcalc (t_mod, "f40",
               "f40-(f41*"//poffset//")+(f42*("//poffset//"**2))",
               datatype="double", colunits="", colfmt="")
        tcalc (t_mod, "f41",
               "f41 - (2*f42*"//poffset//")",
               datatype="double", colunits="", colfmt="")

        tcalc (t_mod, "f50",
               "f50-(f51*"//poffset//")+(f52*("//poffset//"**2))",
               datatype="double", colunits="", colfmt="")
        tcalc (t_mod, "f51",
               "f51 - (2*f52*"//poffset//")",
               datatype="double", colunits="", colfmt="")

        # Get a table containing the unaffected rows.
        tselect (pinput, t_stable, un_select)

        # Now combine the tables into the final output table.
        tmerge (t_stable//","//t_mod, poutput, "append", allcols=yes,
                tbltype="default", allrows=100, extracol=0)
        tsort (poutput, columns="grating,carpos", ascend=yes, casesens=no)
end
