        SUBROUTINE ZSFUNC(XDEF,DIODE,AFUNC,N)
*
*  Module number: 13.8.1.3
*
*  Module name: ZSFUNC
*
*  Keyphrase:
*  ----------
*       Compute sample mapping function terms
*  Description:
*  ------------
*       This routine computes the terms for the sample mapping
*       least squares fit done by routine LFIT2.
*
*               afunc(1) = 1    (constant term)
*               afunc(2) = xdef-2048
*               afunc(3) = diode
*  FORTRAN name: zsfunc.for
*
*  Keywords of accessed files and tables:
*  --------------------------------------
*       none
*
*  Subroutines Called:
*  -------------------
*       none
*
*  History:
*  --------
*  Version      Date        Author          Description
*    1        Dec 15, 1987  D. Lindler   Designed and coded
*-------------------------------------------------------------------------------
C
C Input parameters:
C
C       XDEF - x-deflection (real*8)
C       DIODE - diode number (real*8)
C       N - number of terms to compute (ignored)
C
C Output parameters:
C       AFUNC - function values (real*8 array of 3 elements)
C-------------------------------------------------------------------------
        DOUBLE PRECISION  XDEF,DIODE,AFUNC(3)
        INTEGER N
C
        AFUNC(1)=1.0D0
        AFUNC(2)=XDEF-2048.0D0
        AFUNC(3)=DIODE
        RETURN
        END
