        SUBROUTINE ZYDFUN(WAVE,MW,AFUNC,N)
*
*  Module number: 13.3.3.2.2
*
*  Module name: zydfun
*
*  Keyphrase:
*  ----------
*       Y-deflection function
*  Description:
*  ------------
*       This routine computes the terms of the HRS y-deflection
*       calibration function
*               AFUNC(1) = 1.0          constant term
*                    (2) = wave
*                    (3) = wave**2
*                    (4) = order*wave   (MW)
*  FORTRAN name: zydfun
*
*  Keywords of accessed files and tables:
*  --------------------------------------
*       NONE
*
*  Subroutines Called:
*  -------------------
*       NONE
*
*  History:
*  --------
*  Version      Date        Author          Description
*    1         Dec 87      D. Lindler    Designed and coded
*-------------------------------------------------------------------------------
C
C input parameters
C
        DOUBLE PRECISION        WAVE
C                                    --->WAVELENGTH
        DOUBLE PRECISION        MW
C                                    --->ORDER * WAVELENGTH
        INTEGER                 N
C                                    --->NUMBER OF TERMS
C
C OUTPUT PARAMETERS
C
        DOUBLE PRECISION        AFUNC(4)
C                                    --->terms of the function
C------------------------------------------------------------------------------
        AFUNC(1)=1.0
        AFUNC(2)=WAVE
        AFUNC(3)=WAVE*WAVE
        AFUNC(4)=MW
        RETURN
        END
